/* Automatically generated by AST.sh -- do not edit */
#include "AST.hpp"
namespace AST {



  void ASTNode::read(XMListream &r) {
    Node::read(r); 
  }

  void ASTNode::write(XMLostream &w) const {
    Node::write(w); 
  }

  
  

  void Symbol::read(XMListream &r) {
    ASTNode::read(r); 
    r >> name;
  }

  void Symbol::write(XMLostream &w) const {
    ASTNode::write(w); 
    w << name;
  }

  
  

  void ModuleSymbol::read(XMListream &r) {
    Symbol::read(r); 
    r >> module;
  }

  void ModuleSymbol::write(XMLostream &w) const {
    Symbol::write(w); 
    w << module;
  }

  IRCLASS(ModuleSymbol);
  Status ModuleSymbol::welcome(Visitor &v) { return v.visit(*this); }
  
  

  void SignalSymbol::read(XMListream &r) {
    Symbol::read(r); 
    r >> type >> direction >> combine >> initializer >> presence >> value;
  }

  void SignalSymbol::write(XMLostream &w) const {
    Symbol::write(w); 
    w << type << direction << combine << initializer << presence << value;
  }

  IRCLASS(SignalSymbol);
  Status SignalSymbol::welcome(Visitor &v) { return v.visit(*this); }
  
  

  void BuiltinSignalSymbol::read(XMListream &r) {
    SignalSymbol::read(r); 
  }

  void BuiltinSignalSymbol::write(XMLostream &w) const {
    SignalSymbol::write(w); 
  }

  IRCLASS(BuiltinSignalSymbol);
  Status BuiltinSignalSymbol::welcome(Visitor &v) { return v.visit(*this); }
  
  

  void TrapSymbol::read(XMListream &r) {
    Symbol::read(r); 
    r >> type >> initializer >> code >> presence >> value;
  }

  void TrapSymbol::write(XMLostream &w) const {
    Symbol::write(w); 
    w << type << initializer << code << presence << value;
  }

  IRCLASS(TrapSymbol);
  Status TrapSymbol::welcome(Visitor &v) { return v.visit(*this); }
  
  

  void VariableSymbol::read(XMListream &r) {
    Symbol::read(r); 
    r >> type >> initializer;
  }

  void VariableSymbol::write(XMLostream &w) const {
    Symbol::write(w); 
    w << type << initializer;
  }

  IRCLASS(VariableSymbol);
  Status VariableSymbol::welcome(Visitor &v) { return v.visit(*this); }
  
  

  void ConstantSymbol::read(XMListream &r) {
    VariableSymbol::read(r); 
  }

  void ConstantSymbol::write(XMLostream &w) const {
    VariableSymbol::write(w); 
  }

  IRCLASS(ConstantSymbol);
  Status ConstantSymbol::welcome(Visitor &v) { return v.visit(*this); }
  
  

  void BuiltinConstantSymbol::read(XMListream &r) {
    ConstantSymbol::read(r); 
  }

  void BuiltinConstantSymbol::write(XMLostream &w) const {
    ConstantSymbol::write(w); 
  }

  IRCLASS(BuiltinConstantSymbol);
  Status BuiltinConstantSymbol::welcome(Visitor &v) { return v.visit(*this); }
  
  

  void TypeSymbol::read(XMListream &r) {
    Symbol::read(r); 
  }

  void TypeSymbol::write(XMLostream &w) const {
    Symbol::write(w); 
  }

  IRCLASS(TypeSymbol);
  Status TypeSymbol::welcome(Visitor &v) { return v.visit(*this); }
  
  

  void BuiltinTypeSymbol::read(XMListream &r) {
    TypeSymbol::read(r); 
  }

  void BuiltinTypeSymbol::write(XMLostream &w) const {
    TypeSymbol::write(w); 
  }

  IRCLASS(BuiltinTypeSymbol);
  Status BuiltinTypeSymbol::welcome(Visitor &v) { return v.visit(*this); }
  
  

  void FunctionSymbol::read(XMListream &r) {
    TypeSymbol::read(r); 
    r >> arguments >> result;
  }

  void FunctionSymbol::write(XMLostream &w) const {
    TypeSymbol::write(w); 
    w << arguments << result;
  }

  IRCLASS(FunctionSymbol);
  Status FunctionSymbol::welcome(Visitor &v) { return v.visit(*this); }
  
  

  void BuiltinFunctionSymbol::read(XMListream &r) {
    FunctionSymbol::read(r); 
  }

  void BuiltinFunctionSymbol::write(XMLostream &w) const {
    FunctionSymbol::write(w); 
  }

  IRCLASS(BuiltinFunctionSymbol);
  Status BuiltinFunctionSymbol::welcome(Visitor &v) { return v.visit(*this); }
  
  

  void ProcedureSymbol::read(XMListream &r) {
    TypeSymbol::read(r); 
    r >> reference_arguments >> value_arguments;
  }

  void ProcedureSymbol::write(XMLostream &w) const {
    TypeSymbol::write(w); 
    w << reference_arguments << value_arguments;
  }

  IRCLASS(ProcedureSymbol);
  Status ProcedureSymbol::welcome(Visitor &v) { return v.visit(*this); }
  
  

  void TaskSymbol::read(XMListream &r) {
    ProcedureSymbol::read(r); 
  }

  void TaskSymbol::write(XMLostream &w) const {
    ProcedureSymbol::write(w); 
  }

  IRCLASS(TaskSymbol);
  Status TaskSymbol::welcome(Visitor &v) { return v.visit(*this); }
  
  

  void SymbolTable::read(XMListream &r) {
    ASTNode::read(r); 
    r >> parent >> symbols;
  }

  void SymbolTable::write(XMLostream &w) const {
    ASTNode::write(w); 
    w << parent << symbols;
  }

  IRCLASS(SymbolTable);
  Status SymbolTable::welcome(Visitor &v) { return v.visit(*this); }
  
bool SymbolTable::local_contains(const string s) const {
  return symbols.find(s) != symbols.end();
}

bool SymbolTable::contains(const string s) const {
  for ( const SymbolTable *st = this ; st ; st = st->parent )
    if (st->symbols.find(s) != st->symbols.end()) return true;
  return false;
}

void SymbolTable::enter(Symbol *sym) {
  assert(sym);
  assert(symbols.find(sym->name) == symbols.end());
  symbols.insert( std::make_pair(sym->name, sym) );
}

Symbol* SymbolTable::get(const string s) {
  map<string, Symbol*>::const_iterator i;
  for ( SymbolTable *st = this; st ; st = st->parent ) {
    i = st->symbols.find(s);
    if (i != st->symbols.end()) {
      assert((*i).second);
      assert((*i).second->name == s);
      return (*i).second;
    }
  }
  assert(0); // get should not be called unless contains returned true
}

  

  void Expression::read(XMListream &r) {
    ASTNode::read(r); 
    r >> type;
  }

  void Expression::write(XMLostream &w) const {
    ASTNode::write(w); 
    w << type;
  }

  
  

  void Literal::read(XMListream &r) {
    Expression::read(r); 
    r >> value;
  }

  void Literal::write(XMLostream &w) const {
    Expression::write(w); 
    w << value;
  }

  IRCLASS(Literal);
  Status Literal::welcome(Visitor &v) { return v.visit(*this); }
  
  

  void LoadVariableExpression::read(XMListream &r) {
    Expression::read(r); 
    r >> variable;
  }

  void LoadVariableExpression::write(XMLostream &w) const {
    Expression::write(w); 
    w << variable;
  }

  IRCLASS(LoadVariableExpression);
  Status LoadVariableExpression::welcome(Visitor &v) { return v.visit(*this); }
  
  

  void LoadSignalExpression::read(XMListream &r) {
    Expression::read(r); 
    r >> signal;
  }

  void LoadSignalExpression::write(XMLostream &w) const {
    Expression::write(w); 
    w << signal;
  }

  IRCLASS(LoadSignalExpression);
  Status LoadSignalExpression::welcome(Visitor &v) { return v.visit(*this); }
  
  

  void LoadSignalValueExpression::read(XMListream &r) {
    LoadSignalExpression::read(r); 
  }

  void LoadSignalValueExpression::write(XMLostream &w) const {
    LoadSignalExpression::write(w); 
  }

  IRCLASS(LoadSignalValueExpression);
  Status LoadSignalValueExpression::welcome(Visitor &v) { return v.visit(*this); }
  
  

  void LoadTrapExpression::read(XMListream &r) {
    Expression::read(r); 
    r >> trap;
  }

  void LoadTrapExpression::write(XMLostream &w) const {
    Expression::write(w); 
    w << trap;
  }

  IRCLASS(LoadTrapExpression);
  Status LoadTrapExpression::welcome(Visitor &v) { return v.visit(*this); }
  
  

  void LoadTrapValueExpression::read(XMListream &r) {
    LoadTrapExpression::read(r); 
  }

  void LoadTrapValueExpression::write(XMLostream &w) const {
    LoadTrapExpression::write(w); 
  }

  IRCLASS(LoadTrapValueExpression);
  Status LoadTrapValueExpression::welcome(Visitor &v) { return v.visit(*this); }
  
  

  void UnaryOp::read(XMListream &r) {
    Expression::read(r); 
    r >> op >> source;
  }

  void UnaryOp::write(XMLostream &w) const {
    Expression::write(w); 
    w << op << source;
  }

  IRCLASS(UnaryOp);
  Status UnaryOp::welcome(Visitor &v) { return v.visit(*this); }
  
  

  void BinaryOp::read(XMListream &r) {
    Expression::read(r); 
    r >> op >> source1 >> source2;
  }

  void BinaryOp::write(XMLostream &w) const {
    Expression::write(w); 
    w << op << source1 << source2;
  }

  IRCLASS(BinaryOp);
  Status BinaryOp::welcome(Visitor &v) { return v.visit(*this); }
  
  

  void FunctionCall::read(XMListream &r) {
    Expression::read(r); 
    r >> callee >> arguments;
  }

  void FunctionCall::write(XMLostream &w) const {
    Expression::write(w); 
    w << callee << arguments;
  }

  IRCLASS(FunctionCall);
  Status FunctionCall::welcome(Visitor &v) { return v.visit(*this); }
  
  

  void Delay::read(XMListream &r) {
    Expression::read(r); 
    r >> predicate >> count >> counter >> is_immediate;
  }

  void Delay::write(XMLostream &w) const {
    Expression::write(w); 
    w << predicate << count << counter << is_immediate;
  }

  IRCLASS(Delay);
  Status Delay::welcome(Visitor &v) { return v.visit(*this); }
  
  

  void CheckCounter::read(XMListream &r) {
    Expression::read(r); 
    r >> counter;
  }

  void CheckCounter::write(XMLostream &w) const {
    Expression::write(w); 
    w << counter;
  }

  IRCLASS(CheckCounter);
  Status CheckCounter::welcome(Visitor &v) { return v.visit(*this); }
  
  

  void Module::read(XMListream &r) {
    ASTNode::read(r); 
    r >> symbol >> types >> constants >> functions >> procedures >> tasks >> signals >> variables >> relations >> body >> max_code;
  }

  void Module::write(XMLostream &w) const {
    ASTNode::write(w); 
    w << symbol << types << constants << functions << procedures << tasks << signals << variables << relations << body << max_code;
  }

  IRCLASS(Module);
  Status Module::welcome(Visitor &v) { return v.visit(*this); }
  
Module::Module(ModuleSymbol *s) : symbol(s), body(NULL) {
  signals = new SymbolTable();
  constants = new SymbolTable();
  types = new SymbolTable();
  functions = new SymbolTable();
  procedures = new SymbolTable();
  tasks = new SymbolTable();
  variables = new SymbolTable();
}

Module::~Module() {
   delete signals;
   delete types;
   delete constants;
   delete functions;
   delete procedures;
   delete tasks;
   delete body;
   delete variables;
}
  

  void InputRelation::read(XMListream &r) {
    ASTNode::read(r); 
  }

  void InputRelation::write(XMLostream &w) const {
    ASTNode::write(w); 
  }

  
  

  void Exclusion::read(XMListream &r) {
    InputRelation::read(r); 
    r >> signals;
  }

  void Exclusion::write(XMLostream &w) const {
    InputRelation::write(w); 
    w << signals;
  }

  IRCLASS(Exclusion);
  Status Exclusion::welcome(Visitor &v) { return v.visit(*this); }
  
  

  void Implication::read(XMListream &r) {
    InputRelation::read(r); 
    r >> predicate >> implication;
  }

  void Implication::write(XMLostream &w) const {
    InputRelation::write(w); 
    w << predicate << implication;
  }

  IRCLASS(Implication);
  Status Implication::welcome(Visitor &v) { return v.visit(*this); }
  
  

  void Modules::read(XMListream &r) {
    ASTNode::read(r); 
    r >> module_symbols >> modules;
  }

  void Modules::write(XMLostream &w) const {
    ASTNode::write(w); 
    w << module_symbols << modules;
  }

  IRCLASS(Modules);
  Status Modules::welcome(Visitor &v) { return v.visit(*this); }
  
void Modules::add(Module* m) {
  assert(m);
  assert(m->symbol);
  assert(!module_symbols.contains(m->symbol->name));
  modules.push_back(m);
  module_symbols.enter(m->symbol);
}
  

  void Statement::read(XMListream &r) {
    ASTNode::read(r); 
  }

  void Statement::write(XMLostream &w) const {
    ASTNode::write(w); 
  }

  
  

  void BodyStatement::read(XMListream &r) {
    Statement::read(r); 
    r >> body;
  }

  void BodyStatement::write(XMLostream &w) const {
    Statement::write(w); 
    w << body;
  }

  
  

  void PredicatedStatement::read(XMListream &r) {
    BodyStatement::read(r); 
    r >> predicate;
  }

  void PredicatedStatement::write(XMLostream &w) const {
    BodyStatement::write(w); 
    w << predicate;
  }

  IRCLASS(PredicatedStatement);
  Status PredicatedStatement::welcome(Visitor &v) { return v.visit(*this); }
  
  

  void CaseStatement::read(XMListream &r) {
    Statement::read(r); 
    r >> cases >> default_stmt;
  }

  void CaseStatement::write(XMLostream &w) const {
    Statement::write(w); 
    w << cases << default_stmt;
  }

  
  

  void StatementList::read(XMListream &r) {
    Statement::read(r); 
    r >> statements;
  }

  void StatementList::write(XMLostream &w) const {
    Statement::write(w); 
    w << statements;
  }

  IRCLASS(StatementList);
  Status StatementList::welcome(Visitor &v) { return v.visit(*this); }
  
  

  void ParallelStatementList::read(XMListream &r) {
    Statement ::read(r); 
    r >> threads;
  }

  void ParallelStatementList::write(XMLostream &w) const {
    Statement ::write(w); 
    w << threads;
  }

  IRCLASS(ParallelStatementList);
  Status ParallelStatementList::welcome(Visitor &v) { return v.visit(*this); }
  
  

  void Nothing::read(XMListream &r) {
    Statement::read(r); 
  }

  void Nothing::write(XMLostream &w) const {
    Statement::write(w); 
  }

  IRCLASS(Nothing);
  Status Nothing::welcome(Visitor &v) { return v.visit(*this); }
  
  

  void Pause::read(XMListream &r) {
    Statement::read(r); 
  }

  void Pause::write(XMLostream &w) const {
    Statement::write(w); 
  }

  IRCLASS(Pause);
  Status Pause::welcome(Visitor &v) { return v.visit(*this); }
  
  

  void Halt::read(XMListream &r) {
    Statement::read(r); 
  }

  void Halt::write(XMLostream &w) const {
    Statement::write(w); 
  }

  IRCLASS(Halt);
  Status Halt::welcome(Visitor &v) { return v.visit(*this); }
  
  

  void StartCounter::read(XMListream &r) {
    Statement::read(r); 
    r >> predicate >> startvalue >> counter >> st;
  }

  void StartCounter::write(XMLostream &w) const {
    Statement::write(w); 
    w << predicate << startvalue << counter << st;
  }

  IRCLASS(StartCounter);
  Status StartCounter::welcome(Visitor &v) { return v.visit(*this); }
  
  

  void Emit::read(XMListream &r) {
    Statement::read(r); 
    r >> signal >> value;
  }

  void Emit::write(XMLostream &w) const {
    Statement::write(w); 
    w << signal << value;
  }

  IRCLASS(Emit);
  Status Emit::welcome(Visitor &v) { return v.visit(*this); }
  
  

  void Sustain::read(XMListream &r) {
    Emit::read(r); 
  }

  void Sustain::write(XMLostream &w) const {
    Emit::write(w); 
  }

  IRCLASS(Sustain);
  Status Sustain::welcome(Visitor &v) { return v.visit(*this); }
  
  

  void Assignment::read(XMListream &r) {
    Statement::read(r); 
    r >> variable >> value;
  }

  void Assignment::write(XMLostream &w) const {
    Statement::write(w); 
    w << variable << value;
  }

  IRCLASS(Assignment);
  Status Assignment::welcome(Visitor &v) { return v.visit(*this); }
  
  

  void ProcedureCall::read(XMListream &r) {
    Statement::read(r); 
    r >> procedure >> reference_args >> value_args;
  }

  void ProcedureCall::write(XMLostream &w) const {
    Statement::write(w); 
    w << procedure << reference_args << value_args;
  }

  IRCLASS(ProcedureCall);
  Status ProcedureCall::welcome(Visitor &v) { return v.visit(*this); }
  
  

  void Present::read(XMListream &r) {
    CaseStatement::read(r); 
  }

  void Present::write(XMLostream &w) const {
    CaseStatement::write(w); 
  }

  IRCLASS(Present);
  Status Present::welcome(Visitor &v) { return v.visit(*this); }
  
  

  void If::read(XMListream &r) {
    CaseStatement::read(r); 
  }

  void If::write(XMLostream &w) const {
    CaseStatement::write(w); 
  }

  IRCLASS(If);
  Status If::welcome(Visitor &v) { return v.visit(*this); }
  
  

  void Loop::read(XMListream &r) {
    BodyStatement::read(r); 
  }

  void Loop::write(XMLostream &w) const {
    BodyStatement::write(w); 
  }

  IRCLASS(Loop);
  Status Loop::welcome(Visitor &v) { return v.visit(*this); }
  
  

  void Repeat::read(XMListream &r) {
    Loop::read(r); 
    r >> count >> is_positive;
  }

  void Repeat::write(XMLostream &w) const {
    Loop::write(w); 
    w << count << is_positive;
  }

  IRCLASS(Repeat);
  Status Repeat::welcome(Visitor &v) { return v.visit(*this); }
  
  

  void Abort::read(XMListream &r) {
    CaseStatement::read(r); 
    r >> body >> is_weak >> code;
  }

  void Abort::write(XMLostream &w) const {
    CaseStatement::write(w); 
    w << body << is_weak << code;
  }

  IRCLASS(Abort);
  Status Abort::welcome(Visitor &v) { return v.visit(*this); }
  
  

  void Await::read(XMListream &r) {
    CaseStatement::read(r); 
  }

  void Await::write(XMLostream &w) const {
    CaseStatement::write(w); 
  }

  IRCLASS(Await);
  Status Await::welcome(Visitor &v) { return v.visit(*this); }
  
  

  void LoopEach::read(XMListream &r) {
    PredicatedStatement::read(r); 
  }

  void LoopEach::write(XMLostream &w) const {
    PredicatedStatement::write(w); 
  }

  IRCLASS(LoopEach);
  Status LoopEach::welcome(Visitor &v) { return v.visit(*this); }
  
  

  void Every::read(XMListream &r) {
    PredicatedStatement::read(r); 
  }

  void Every::write(XMLostream &w) const {
    PredicatedStatement::write(w); 
  }

  IRCLASS(Every);
  Status Every::welcome(Visitor &v) { return v.visit(*this); }
  
  

  void Suspend::read(XMListream &r) {
    PredicatedStatement::read(r); 
  }

  void Suspend::write(XMLostream &w) const {
    PredicatedStatement::write(w); 
  }

  IRCLASS(Suspend);
  Status Suspend::welcome(Visitor &v) { return v.visit(*this); }
  
  

  void DoWatching::read(XMListream &r) {
    PredicatedStatement::read(r); 
    r >> timeout;
  }

  void DoWatching::write(XMLostream &w) const {
    PredicatedStatement::write(w); 
    w << timeout;
  }

  IRCLASS(DoWatching);
  Status DoWatching::welcome(Visitor &v) { return v.visit(*this); }
  
  

  void DoUpto::read(XMListream &r) {
    PredicatedStatement::read(r); 
  }

  void DoUpto::write(XMLostream &w) const {
    PredicatedStatement::write(w); 
  }

  IRCLASS(DoUpto);
  Status DoUpto::welcome(Visitor &v) { return v.visit(*this); }
  
  

  void TaskCall::read(XMListream &r) {
    ProcedureCall::read(r); 
    r >> signal >> body;
  }

  void TaskCall::write(XMLostream &w) const {
    ProcedureCall::write(w); 
    w << signal << body;
  }

  IRCLASS(TaskCall);
  Status TaskCall::welcome(Visitor &v) { return v.visit(*this); }
  
  

  void Exec::read(XMListream &r) {
    Statement::read(r); 
    r >> calls;
  }

  void Exec::write(XMLostream &w) const {
    Statement::write(w); 
    w << calls;
  }

  IRCLASS(Exec);
  Status Exec::welcome(Visitor &v) { return v.visit(*this); }
  
  

  void ScopeStatement::read(XMListream &r) {
    BodyStatement::read(r); 
    r >> symbols;
  }

  void ScopeStatement::write(XMLostream &w) const {
    BodyStatement::write(w); 
    w << symbols;
  }

  
  

  void Trap::read(XMListream &r) {
    ScopeStatement::read(r); 
    r >> handlers;
  }

  void Trap::write(XMLostream &w) const {
    ScopeStatement::write(w); 
    w << handlers;
  }

  IRCLASS(Trap);
  Status Trap::welcome(Visitor &v) { return v.visit(*this); }
  
  

  void Exit::read(XMListream &r) {
    Statement::read(r); 
    r >> trap >> value;
  }

  void Exit::write(XMLostream &w) const {
    Statement::write(w); 
    w << trap << value;
  }

  IRCLASS(Exit);
  Status Exit::welcome(Visitor &v) { return v.visit(*this); }
  
  

  void Signal::read(XMListream &r) {
    ScopeStatement::read(r); 
  }

  void Signal::write(XMLostream &w) const {
    ScopeStatement::write(w); 
  }

  IRCLASS(Signal);
  Status Signal::welcome(Visitor &v) { return v.visit(*this); }
  
  

  void Var::read(XMListream &r) {
    ScopeStatement::read(r); 
  }

  void Var::write(XMLostream &w) const {
    ScopeStatement::write(w); 
  }

  IRCLASS(Var);
  Status Var::welcome(Visitor &v) { return v.visit(*this); }
  
  

  void Renaming::read(XMListream &r) {
    ASTNode::read(r); 
    r >> old_name;
  }

  void Renaming::write(XMLostream &w) const {
    ASTNode::write(w); 
    w << old_name;
  }

  
  

  void TypeRenaming::read(XMListream &r) {
    Renaming::read(r); 
    r >> new_type;
  }

  void TypeRenaming::write(XMLostream &w) const {
    Renaming::write(w); 
    w << new_type;
  }

  IRCLASS(TypeRenaming);
  Status TypeRenaming::welcome(Visitor &v) { return v.visit(*this); }
  
  

  void ConstantRenaming::read(XMListream &r) {
    Renaming::read(r); 
    r >> new_value;
  }

  void ConstantRenaming::write(XMLostream &w) const {
    Renaming::write(w); 
    w << new_value;
  }

  IRCLASS(ConstantRenaming);
  Status ConstantRenaming::welcome(Visitor &v) { return v.visit(*this); }
  
  

  void FunctionRenaming::read(XMListream &r) {
    Renaming::read(r); 
    r >> new_func;
  }

  void FunctionRenaming::write(XMLostream &w) const {
    Renaming::write(w); 
    w << new_func;
  }

  IRCLASS(FunctionRenaming);
  Status FunctionRenaming::welcome(Visitor &v) { return v.visit(*this); }
  
  

  void ProcedureRenaming::read(XMListream &r) {
    Renaming::read(r); 
    r >> new_proc;
  }

  void ProcedureRenaming::write(XMLostream &w) const {
    Renaming::write(w); 
    w << new_proc;
  }

  IRCLASS(ProcedureRenaming);
  Status ProcedureRenaming::welcome(Visitor &v) { return v.visit(*this); }
  
  

  void SignalRenaming::read(XMListream &r) {
    Renaming::read(r); 
    r >> new_sig;
  }

  void SignalRenaming::write(XMLostream &w) const {
    Renaming::write(w); 
    w << new_sig;
  }

  IRCLASS(SignalRenaming);
  Status SignalRenaming::welcome(Visitor &v) { return v.visit(*this); }
  
  

  void Run::read(XMListream &r) {
    Statement::read(r); 
    r >> old_name >> new_name >> types >> constants >> functions >> procedures >> tasks >> signals;
  }

  void Run::write(XMLostream &w) const {
    Statement::write(w); 
    w << old_name << new_name << types << constants << functions << procedures << tasks << signals;
  }

  IRCLASS(Run);
  Status Run::welcome(Visitor &v) { return v.visit(*this); }
  
  

  void IfThenElse::read(XMListream &r) {
    Statement::read(r); 
    r >> predicate >> then_part >> else_part;
  }

  void IfThenElse::write(XMLostream &w) const {
    Statement::write(w); 
    w << predicate << then_part << else_part;
  }

  IRCLASS(IfThenElse);
  Status IfThenElse::welcome(Visitor &v) { return v.visit(*this); }
  
  

  void Goto::read(XMListream &r) {
    Statement::read(r); 
    r >> target;
  }

  void Goto::write(XMLostream &w) const {
    Statement::write(w); 
    w << target;
  }

  IRCLASS(Goto);
  Status Goto::welcome(Visitor &v) { return v.visit(*this); }
  
  

  void Label::read(XMListream &r) {
    Statement::read(r); 
    r >> name;
  }

  void Label::write(XMLostream &w) const {
    Statement::write(w); 
    w << name;
  }

  IRCLASS(Label);
  Status Label::welcome(Visitor &v) { return v.visit(*this); }
  
  

  void Catch::read(XMListream &r) {
    BodyStatement::read(r); 
    r >> code >> label;
  }

  void Catch::write(XMLostream &w) const {
    BodyStatement::write(w); 
    w << code << label;
  }

  IRCLASS(Catch);
  Status Catch::welcome(Visitor &v) { return v.visit(*this); }
  
  

  void Handler::read(XMListream &r) {
    Statement::read(r); 
    r >> catches >> catch0;
  }

  void Handler::write(XMLostream &w) const {
    Statement::write(w); 
    w << catches << catch0;
  }

  
  

  void Try::read(XMListream &r) {
    Handler::read(r); 
    r >> body;
  }

  void Try::write(XMLostream &w) const {
    Handler::write(w); 
    w << body;
  }

  IRCLASS(Try);
  Status Try::welcome(Visitor &v) { return v.visit(*this); }
  
  

  void Break::read(XMListream &r) {
    Statement::read(r); 
    r >> level >> continue_target >> set_state;
  }

  void Break::write(XMLostream &w) const {
    Statement::write(w); 
    w << level << continue_target << set_state;
  }

  IRCLASS(Break);
  Status Break::welcome(Visitor &v) { return v.visit(*this); }
  
  

  void Continuable::read(XMListream &r) {
    Handler::read(r); 
    r >> continue_label;
  }

  void Continuable::write(XMLostream &w) const {
    Handler::write(w); 
    w << continue_label;
  }

  
  

  void Resume::read(XMListream &r) {
    Continuable::read(r); 
    r >> body >> branch;
  }

  void Resume::write(XMLostream &w) const {
    Continuable::write(w); 
    w << body << branch;
  }

  IRCLASS(Resume);
  Status Resume::welcome(Visitor &v) { return v.visit(*this); }
  
  

  void Continue::read(XMListream &r) {
    Statement::read(r); 
  }

  void Continue::write(XMLostream &w) const {
    Statement::write(w); 
  }

  IRCLASS(Continue);
  Status Continue::welcome(Visitor &v) { return v.visit(*this); }
  
  

  void Thread::read(XMListream &r) {
    Resume::read(r); 
    r >> exit_level;
  }

  void Thread::write(XMLostream &w) const {
    Resume::write(w); 
    w << exit_level;
  }

  IRCLASS(Thread);
  Status Thread::welcome(Visitor &v) { return v.visit(*this); }
  
  

  void Parallel::read(XMListream &r) {
    Continuable::read(r); 
    r >> threads >> synchronize;
  }

  void Parallel::write(XMLostream &w) const {
    Continuable::write(w); 
    w << threads << synchronize;
  }

  IRCLASS(Parallel);
  Status Parallel::welcome(Visitor &v) { return v.visit(*this); }
  
  

  void GRCNode::read(XMListream &r) {
    ASTNode::read(r); 
    r >> predecessors >> successors;
  }

  void GRCNode::write(XMLostream &w) const {
    ASTNode::write(w); 
    w << predecessors << successors;
  }

  
  GRCNode& GRCNode::operator >>(GRCNode * s) {
    successors.push_back(s);
    if (s) s->predecessors.push_back(this);
    return *this;
  }

  

  void STNode::read(XMListream &r) {
    GRCNode::read(r); 
  }

  void STNode::write(XMLostream &w) const {
    GRCNode::write(w); 
  }

  IRCLASS(STNode);
  Status STNode::welcome(Visitor &v) { return v.visit(*this); }
  
  

  void STexcl::read(XMListream &r) {
    STNode::read(r); 
  }

  void STexcl::write(XMLostream &w) const {
    STNode::write(w); 
  }

  IRCLASS(STexcl);
  Status STexcl::welcome(Visitor &v) { return v.visit(*this); }
  
  

  void STpar::read(XMListream &r) {
    STNode::read(r); 
  }

  void STpar::write(XMLostream &w) const {
    STNode::write(w); 
  }

  IRCLASS(STpar);
  Status STpar::welcome(Visitor &v) { return v.visit(*this); }
  
  

  void STref::read(XMListream &r) {
    STNode::read(r); 
    r >> type;
  }

  void STref::write(XMLostream &w) const {
    STNode::write(w); 
    w << type;
  }

  IRCLASS(STref);
  Status STref::welcome(Visitor &v) { return v.visit(*this); }
  
  

  void STleaf::read(XMListream &r) {
    STNode::read(r); 
    r >> type;
  }

  void STleaf::write(XMLostream &w) const {
    STNode::write(w); 
    w << type;
  }

  IRCLASS(STleaf);
  Status STleaf::welcome(Visitor &v) { return v.visit(*this); }
  
  

  void TopGRC::read(XMListream &r) {
    GRCNode::read(r); 
  }

  void TopGRC::write(XMLostream &w) const {
    GRCNode::write(w); 
  }

  IRCLASS(TopGRC);
  Status TopGRC::welcome(Visitor &v) { return v.visit(*this); }
  
  

  void Nop::read(XMListream &r) {
    GRCNode::read(r); 
    r >> type >> code;
  }

  void Nop::write(XMLostream &w) const {
    GRCNode::write(w); 
    w << type << code;
  }

  IRCLASS(Nop);
  Status Nop::welcome(Visitor &v) { return v.visit(*this); }
  
  

  void RecT1::read(XMListream &r) {
    GRCNode::read(r); 
  }

  void RecT1::write(XMLostream &w) const {
    GRCNode::write(w); 
  }

  IRCLASS(RecT1);
  Status RecT1::welcome(Visitor &v) { return v.visit(*this); }
  
  

  void DefineSignal::read(XMListream &r) {
    GRCNode::read(r); 
    r >> signals;
  }

  void DefineSignal::write(XMLostream &w) const {
    GRCNode::write(w); 
    w << signals;
  }

  IRCLASS(DefineSignal);
  Status DefineSignal::welcome(Visitor &v) { return v.visit(*this); }
  
  

  void UndefineSignal::read(XMListream &r) {
    GRCNode::read(r); 
    r >> signals;
  }

  void UndefineSignal::write(XMLostream &w) const {
    GRCNode::write(w); 
    w << signals;
  }

  IRCLASS(UndefineSignal);
  Status UndefineSignal::welcome(Visitor &v) { return v.visit(*this); }
  
  

  void Switch::read(XMListream &r) {
    GRCNode::read(r); 
    r >> st;
  }

  void Switch::write(XMLostream &w) const {
    GRCNode::write(w); 
    w << st;
  }

  IRCLASS(Switch);
  Status Switch::welcome(Visitor &v) { return v.visit(*this); }
  
  

  void Test::read(XMListream &r) {
    GRCNode::read(r); 
    r >> predicate >> st;
  }

  void Test::write(XMLostream &w) const {
    GRCNode::write(w); 
    w << predicate << st;
  }

  IRCLASS(Test);
  Status Test::welcome(Visitor &v) { return v.visit(*this); }
  
  

  void Fork::read(XMListream &r) {
    GRCNode::read(r); 
  }

  void Fork::write(XMLostream &w) const {
    GRCNode::write(w); 
  }

  IRCLASS(Fork);
  Status Fork::welcome(Visitor &v) { return v.visit(*this); }
  
  

  void Sync::read(XMListream &r) {
    GRCNode::read(r); 
    r >> st >> depth;
  }

  void Sync::write(XMLostream &w) const {
    GRCNode::write(w); 
    w << st << depth;
  }

  IRCLASS(Sync);
  Status Sync::welcome(Visitor &v) { return v.visit(*this); }
  
  

  void Terminate::read(XMListream &r) {
    GRCNode::read(r); 
    r >> code;
  }

  void Terminate::write(XMLostream &w) const {
    GRCNode::write(w); 
    w << code;
  }

  IRCLASS(Terminate);
  Status Terminate::welcome(Visitor &v) { return v.visit(*this); }
  
  

  void Action::read(XMListream &r) {
    GRCNode::read(r); 
    r >> body;
  }

  void Action::write(XMLostream &w) const {
    GRCNode::write(w); 
    w << body;
  }

  IRCLASS(Action);
  Status Action::welcome(Visitor &v) { return v.visit(*this); }
  
  

  void Enter::read(XMListream &r) {
    GRCNode::read(r); 
    r >> st;
  }

  void Enter::write(XMLostream &w) const {
    GRCNode::write(w); 
    w << st;
  }

  IRCLASS(Enter);
  Status Enter::welcome(Visitor &v) { return v.visit(*this); }
  
  

  void Leave::read(XMListream &r) {
    GRCNode::read(r); 
    r >> st;
  }

  void Leave::write(XMLostream &w) const {
    GRCNode::write(w); 
    w << st;
  }

  IRCLASS(Leave);
  Status Leave::welcome(Visitor &v) { return v.visit(*this); }
  
  

}

