#ifndef _GRCWALKER_
#define _GRCWALKER_

namespace AST{
  class GRCWalker: public Visitor {

    int debug;
    int alive;

    TopGRC *top;
    STNode *stroot;
    Switch *top_sw;
    STleaf *boot;
    Nodemap &refmap;
    std::set<GRCNode *> &reachable;

    
    std::set<GRCNode *> vset;
    map<STNode*, int> states;

  public:
    GRCWalker::GRCWalker(TopGRC *top, STNode *stroot, Switch *top_sw, STleaf *boot, Nodemap &refmap, std::set<GRCNode *> &reachable);
    virtual ~GRCWalker() {}
    
    void visit (GRCNode *);

    Status visit(Switch &);
    Status visit(Test &);
    Status visit(Terminate &);
    Status visit(Sync &);
    Status visit(Fork &);
    Status visit(Action &);
    Status visit(Enter &);
    Status visit(Leave &);

    Status visit(TopGRC &){return Status();}
    Status visit(STexcl &){return Status();}
    Status visit(STref &){return Status();}
    Status visit(STpar &){return Status();}
    Status visit(STleaf &){return Status();}
    
    Status visit(Nop &);
    Status visit(RecT1 &);
    Status visit(DefineSignal &);
    Status visit(UndefineSignal &);

    void execute();

    void add_children(GRCNode *n);
    int anyleafreachable(STNode *n);

  };
}

#endif
