#include "IR.hpp"
#include "AST.hpp"
#include "ASTGRC.hpp"
#include <iostream>
#include <vector>

int main()
{
  try {
    IR::Node *root;
    IR::XMListream r(std::cin);
    r >> root;

    AST::Modules *mods = dynamic_cast<AST::Modules*>(root);
    if (!mods) throw IR::Error("Root node is not a Modules object");

    for ( std::vector<AST::Module*>::iterator i = mods->modules.begin() ;
	  i != mods->modules.end() ; i++ ) {
      assert(*i);
      ASTGRC::GrcSynth synth(*i);
      (*i)->body = synth.synthesize();
      assert((*i)->body);
    }

    IR::XMLostream w(std::cout);
    w << mods;
    
  } catch (IR::Error &e) {
    std::cerr << e.s << std::endl;
    return -1;
  }

  return 0;
}
